HDU 4879 ZCC loves march(并查集+set)

题意:一个最大10^18*10^18的矩阵,给你最多十万个士兵的位置,分别分布在矩阵里,可能会位置重复,然后有2种操作,一种是把第i个士兵向上下左右移动,另一种是把第i个士兵与他横坐标纵坐标相同的士兵全部移到这个点上,然后要计算花费。

这道题我想了好几天。在看了标程得到一些提示后总算写出来了。加了读入优化后快了100ms左右达到546ms。

做法:开2个set分别维护X相同的和Y相同的,但是会有相同位置点的坐标,该怎么办?用并查集去维护相同位置的点,读入的时候就可能会有位置相同的点,所以读的时候就要用,但是又来一个问题,因为第一步操作要移动点,去移动并查集的不是根的节点很容易,直接就可以移动,但是如果要移动那个并查集的根呢?这个问题我百思不得其解。。看了标程中开了一个new数组,然后貌似是往后加。。顿时想通了,原来的点不删除,如果要移动,直接去新加一个点,然后把新点的坐标保存在new里面,同时还要开一个nct数组去保存并查集中有几个节点。如果你需要移动那个并查集的根,新加一个节点后,那个原来的点就没什么意义了,但是在第二个操作合并2个集合的时候这个根还是有用的。还有一点如果你在移动的操作下如果要移动这个节点的根的nct值是1,那么就说明这个集合只有一个有用的点了,虽然可能还有很多其他点。然后要把这个根从set中删除。注意在这里不能简单的判断该节点的父亲是否是自己,因为可能你就是一个并查集的根,你不能确定下面是否还有节点,所以只能从nct数组保存的节点个数来判断。

总体说实现起来真的挺困难。。

AC代码(加了读入优化):

#include<cstdio>
#include<ctype.h>
#include<algorithm>
#include<iostream>
#include<cstring>
#include<vector>
#include<stack>
#include<cmath>
#include<queue>
#include<set>
#include<ctime>
using namespace std;
#define ll __int64
#define MOD 1000000007
const ll Max = 1e18+1;

inline void scan_d(ll &ret) {
    char c; ret=0;
    while((c=getchar())<'0'||c>'9');
    while(c>='0'&&c<='9') ret=ret*10+(c-'0'),c=getchar();
}

struct node
{
    ll x;
    ll y;
    int pp;
    bool operator!=(const node &n1) const
    {
        if(n1.x == x&&n1.y == y) return 0;
        return 1;
    }
};

struct cmpx
{
    bool operator()(const node &n1, const node &n2) const
    {
        if(n1.x == n2.x) return n1.y<n2.y;
        return n1.x<n2.x;
    }
};

struct cmpy
{
    bool operator()(const node &n1, const node &n2) const
    {
        if(n1.y == n2.y) return n1.x<n2.x;
        return n1.y<n2.y;
    }
};

set<node,cmpx>s1;
set<node,cmpy>s2;
int fa[200010];
int nct[200010],nnew[100005];
node po[200010];
int findit(int x)
{
    return fa[x]!=x ? fa[x] = findit(fa[x]):x;
}

void mergeit(int x, int y)
{
    x = findit(x);
    y = findit(y);
    nct[y] += nct[x];
    fa[x] = y;
}

node make(ll x, ll y, int pp)
{
    node t;t.x = x;t.y=y;t.pp=pp;return t;
}
int main()
{
    //freopen("input.txt","r",stdin);
//    freopen("o.txt","w",stdout);
    ll m;
    int n,i,j,t;
    while(~scanf("%d%I64d",&n,&m))
    {
        s1.clear();
        s2.clear();
        s1.insert(make(-1,0,0));
        s1.insert(make(Max,0,0));
        s2.insert(make(0,-1,0));
        s2.insert(make(0,Max,0));
        set<node,cmpx>::iterator itx1,itx2,tmp1;
        set<node,cmpy>::iterator ity1,ity2,tmp2;
        for(i = 1; i <= n; i++)
        {
            fa[i] = i;
            scan_d(po[i].x);scan_d(po[i].y);
//            scanf("%I64d%I64d",&po[i].x,&po[i].y);
            nnew[i] = i;
            po[i].pp = i;
            itx1 = s1.find(po[i]);
            if(itx1 != s1.end())
            {
                nct[i] = 0;
                mergeit(i,itx1->pp);
                nct[itx1->pp]++;
            }
            else
            {
                nct[i] = 1;
                s1.insert(po[i]);
                s2.insert(po[i]);
            }
        }
        char temp;
        scanf("%d\n",&t);
        ll ans = 0;
        while(t--)
        {
            scanf("%c",&temp);
            ll a,b;
            if(temp == 'Q')
            {
                scan_d(a);
//                scanf("%I64d",&a);
                a ^= ans;
                a = nnew[a];
                ans = 0;
                int x = findit(a);
                tmp1 = itx1 = itx2 = s1.lower_bound(po[x]);
                for(;itx1->x == po[x].x;itx1--);
                itx1++;
                for(;itx2->x == po[x].x;itx2++);
                while(itx1!=itx2)
                {
                    if(tmp1!=itx1)
                    {
                        int pos = itx1->pp;
                        ans += ((ll)nct[pos]*(((itx1->y-po[x].y)%MOD*((itx1->y-po[x].y)%MOD))%MOD))%MOD;
                        ans %= MOD;
                        mergeit(pos,x);
                        s2.erase(make(itx1->x,itx1->y,itx1->pp));
                        s1.erase(itx1++);
                    }
                    else itx1++;
                }
                tmp2 = ity1 = ity2 = s2.lower_bound(po[x]);
                for(;ity1->y == po[x].y;ity1--);
                ity1++;
                for(;ity2->y == po[x].y;ity2++);
                while(ity1!=ity2)
                {
                    if(tmp2!=ity1)
                    {
                        int pos = ity1->pp;
                        ans += ((ll)nct[pos]%MOD*(((ity1->x-po[x].x)%MOD*((ity1->x-po[x].x)%MOD))%MOD))%MOD;
                        ans %= MOD;
                        mergeit(pos,x);
                        s1.erase(make(ity1->x,ity1->y,ity1->pp));
                        s2.erase(ity1++);
                    }
                    else ity1++;
                }
                printf("%I64d\n",ans);
            }
            else
            {
                scan_d(a);scan_d(b);
//                scanf("%I64d%I64d",&a,&b);
                a ^= ans;
                int newa = nnew[a];
                if(temp == 'L')
                {
                    int k = findit(newa);
                    if(nct[k] == 1)
                    {
                        s1.erase(po[k]);
                        s2.erase(po[k]);
                    }
                    nct[k]--;
                    node t = make(po[k].x,po[k].y-b,0);
                    itx1 = s1.find(t);
                    po[++n] = t;
                    po[n].pp = n;
                    nnew[a] = n;
                    if(itx1 == s1.end())
                    {
                        fa[n] = n;
                        s1.insert(po[n]);
                        s2.insert(po[n]);
                        nct[n]=1;
                    }
                    else
                    {
                        nct[n]=0;
                        fa[n] = itx1->pp;
                        nct[itx1->pp]++;
                    }
                }
                if(temp == 'R')
                {
                    int k = findit(newa);
                    if(nct[k] == 1)
                    {
                        s1.erase(po[k]);
                        s2.erase(po[k]);
                    }
                    nct[k]--;
                    node t = make(po[k].x,po[k].y+b,0);
                    itx1 = s1.find(t);
                    po[++n] = t;
                    po[n].pp = n;
                    nnew[a] = n;
                    if(itx1 == s1.end())
                    {
                        fa[n] = n;
                        s1.insert(po[n]);
                        s2.insert(po[n]);
                        nct[n]=1;
                    }
                    else
                    {
                        nct[n]=0;
                        fa[n] = itx1->pp;
                        nct[itx1->pp]++;
                    }
                }
                if(temp == 'U')
                {
                    int k = findit(newa);
                    if(nct[k] == 1)
                    {
                        s1.erase(po[k]);
                        s2.erase(po[k]);
                    }
//                    cout<<k<<endl;
                    nct[k]--;
                    node t = make(po[k].x-b,po[k].y,0);
                    itx1 = s1.find(t);
                    po[++n] = t;
                    po[n].pp = n;
                    nnew[a] = n;
                    if(itx1 == s1.end())
                    {
                        fa[n] = n;
                        s1.insert(po[n]);
                        s2.insert(po[n]);
                        nct[n]=1;
                    }
                    else
                    {
                        nct[n]=0;
                        fa[n] = itx1->pp;
                        nct[itx1->pp]++;
                    }
                }
                if(temp == 'D')
                {
                    int k = findit(newa);
                    if(nct[k] == 1)
                    {
                        s1.erase(po[k]);
                        s2.erase(po[k]);
                    }
//                    cout<<k<<endl;
                    nct[k]--;
                    node t = make(po[k].x+b,po[k].y,0);
                    itx1 = s1.find(t);
                    po[++n] = t;
                    po[n].pp = n;
                    nnew[a] = n;
                    if(itx1 == s1.end())
                    {
                        fa[n] = n;
                        s1.insert(po[n]);
                        s2.insert(po[n]);
                        nct[n]=1;
                    }
                    else
                    {
                        nct[n]=0;
                        fa[n] = itx1->pp;
                        nct[itx1->pp]++;
                    }
                }
            }
        }
    }
    return 0;
}

HDU 4879 ZCC loves march(并查集+set)

时间: 2024-10-08 09:04:29

HDU 4879 ZCC loves march(并查集+set)的相关文章

HDU 4879 ZCC loves march (并查集,set,map)

题面以及思路:https://blog.csdn.net/glqac/article/details/38402101 代码: #include <bits/stdc++.h> #define LL long long using namespace std; const LL mod = 1000000007; const int maxn = 2000010; struct node { LL x, y; int cnt; node(){} node(LL x, LL y, int cnt

HDU 4879 ZCC loves march (2014多校2-1008,数据结构,STL,模拟题)

题目: http://acm.hdu.edu.cn/showproblem.php?pid=4879 题意: 给一个n*m的矩阵,有n个人,t次操作,操作有以下两种: 1.令编号x的人上下左右移动 2.令与编号x的人同行同列的人聚集到x这里,输出花费 方法: 使用两个set,一个维护x轴,一个维护y轴 一个map<point,int>,表示这一个point有多少个人 然后根据要求的操作直接操作即可,nlgn复杂度 注意: 1.由于set或者map是红黑树,所以删除节点的后,内部节点重排,it+

hdu 4882 ZCC Loves Codefires(数学题+贪心)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4882 ---------------------------------------------------------------------------------------------------------------------------------------------------------- 欢迎光临天资小屋:http://user.qzone.qq.com/593830943

HDU 4873 ZCC Loves Intersection(JAVA、大数、推公式)

在一个D维空间,只有整点,点的每个维度的值是0~n-1 .现每秒生成D条线段,第i条线段与第i维度的轴平行.问D条线段的相交期望. 生成线段[a1,a2]的方法(假设该线段为第i条,即与第i维度的轴平行)为,i!=j时,a1[j]=a2[j],且随机取区间[0,n-1]内的整数.然后a1[i],a2[i]在保证a1[i]<a2[i]的前提下同样随机. 由于D条线段各自跟自己维度的轴平行,我们可以转换成只求第i个维度与第j个维度的相交期望,然后乘以C(2,n)就好了 显然线段[a1,a2]和线段[

HDU 4876 ZCC loves cards _(:зゝ∠)_ 随机输出保平安

GG,,,g艹 #include <cstdio> #include <iostream> #include <algorithm> #include <string.h> #include <vector> #include <queue> #include <math.h> using namespace std; vector<int>G[21][7];//G[i][j] 表示n=i k=j的情况下 二进

hdu 4882 ZCC Loves Codefires(贪心)

# include<stdio.h> # include <algorithm> # include <string.h> using namespace std; struct node { int v; int t; }; struct node a[100010]; bool cmp(node a,node b) { return a.v *a.t+(a.v+b.v)*b.t<b.v*b.t+(a.v+b.v)*a.t; } int main() { int

HDU 3635 延缓更新的并查集

Dragon Balls Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2839    Accepted Submission(s): 1097 Problem Description Five hundred years later, the number of dragon balls will increase unexpecte

JAVA hdu 4882 ZCC Loves Codefires

题目地址:http://acm.hdu.edu.cn/showproblem.php?pid=4882 题解:参考题后Discuss javaherongwei 的讲解 考察序列中相邻的两题i, j(i在前).交换它们后,解出它们之前的题目所带来的时间对答案的贡献是不变的,它们对它们后面的题目的贡献也是不变的,其他题目之间对答案的贡献自然也是不变的.唯一的变化就是,原来的EiKj一项变成了EjKi一项.那么,为了使答案变优,需要满足的条件是EjKi≤EiKj.也即Ei/Ki≥Ej/Kj.那么,最

HDU 4876 ZCC loves cards

我决定记录下这么恶心的代码.比赛的时候头晕脑胀,写得好搓,错的地方好多好多,回来调了好久.... 做法大概就是C(20,6)选出卡牌后,再k!枚举排列,再k*k得出该排列能得出什么数字. 当然,光这样做绝对会T,里面加了各种剪枝后就1650ms险过了.. 最主要的剪枝是选出k张牌后,看牌能不能组成L~ans里面各个数字,能才进行下一步.然后k!可以拆成(k-x)!*(x!)..不过这里其实大概没什么大优化吧 #include<cstdio> #include<iostream> #